from sqlalchemy import *

import config
import globals

from consts import *
from sqlManager import *

def getRunRepackedPercentage(runid, numStreamers):
    assocTable = Table(TABLES.REPACK_STREAMER_ASSOC, globals.meta, autoload = True, schema = config.DB_SCHEMA)
    repackedTable = Table(TABLES.REPACKED, globals.meta, autoload = True, schema = config.DB_SCHEMA)

    query = select([func.count(func.distinct(assocTable.c.streamer_id))],
                        repackedTable.c.run_id == runid,
                        from_obj=[
                            repackedTable.join(assocTable, repackedTable.c.repacked_id == assocTable.c.repacked_id)
                        ])
    result = executeQuery(query)
    numRepacked = int(result.fetchone()[0])

    if (numStreamers == 0):
        percentage = 100
    else:
        percentage = numRepacked * 100 / numStreamers
    return Percentage(percentage, numRepacked)

#TODO:1:think about optimizing without in
def getRunRepackMergePercentage(runid, numRepacked):
    repackedTable = Table(TABLES.REPACKED, globals.meta, autoload = True, schema = config.DB_SCHEMA)
    parentageTable = Table(TABLES.REPACKED_MERGE_PARENTAGE, globals.meta, autoload = True, schema = config.DB_SCHEMA)

    numMerged = 0

    query = select([func.count(repackedTable.c.repacked_id)],
        repackedTable.c.run_id == runid,
        from_obj = [
            repackedTable.join(parentageTable, repackedTable.c.repacked_id == parentageTable.c.input_id)
        ]
    )
    result = executeQuery(query)
    numMerged += int(result.fetchone()[0])

    query = select([func.count(repackedTable.c.repacked_id)],
        and_(
            repackedTable.c.run_id == runid,
            not_(
                repackedTable.c.repacked_id.in_(
                select([parentageTable.c.output_id])
            )),
            or_(
                repackedTable.c.status == REPACK_RECONSTRUCTION_DISABLED,
                repackedTable.c.status == REPACK_RECONSTRUCTION_QUEUED
            )
        )
    )
    result = executeQuery(query)
    numMerged += int(result.fetchone()[0])

    if numRepacked == 0:
        percentage = 100
    else:
        percentage = numMerged * 100 / numRepacked

    return Percentage(percentage, numMerged)

def getRunRecoPercentage(runid, numReconstructed):
    repackedTable = Table(TABLES.REPACKED, globals.meta, autoload = True, schema = config.DB_SCHEMA)

    query = select([func.count(repackedTable.c.repacked_id)],
                        and_(
                            repackedTable.c.status == REPACK_RECONSTRUCTION_QUEUED,
                            repackedTable.c.run_id == runid
                        )
                    )
    result = executeQuery(query)
    numRepacked = int(result.fetchone()[0])

#    globals.logger.log(str(numRepacked) + " " + str(numReconstructed))
    if (numRepacked == 0):
        percentage = 100
    else:
        percentage = numReconstructed * 100 / numRepacked
    return Percentage(percentage, numReconstructed)

class Percentage:
    def __init__(self, percentage, value = None, total = None):
        self.percentage = percentage
        self.value = value
        self.total = total
